/*
Metal API

# Introduction Equinix Metal provides a RESTful HTTP API which can be reached at <https://api.equinix.com/metal/v1>. This document describes the API and how to use it.  The API allows you to programmatically interact with all of your Equinix Metal resources, including devices, networks, addresses, organizations, projects, and your user account. Every feature of the Equinix Metal web interface is accessible through the API.  The API docs are generated from the Equinix Metal OpenAPI specification and are officially hosted at <https://metal.equinix.com/developers/api>.  # Common Parameters  The Equinix Metal API uses a few methods to minimize network traffic and improve throughput. These parameters are not used in all API calls, but are used often enough to warrant their own section. Look for these parameters in the documentation for the API calls that support them.  ## Pagination  Pagination is used to limit the number of results returned in a single request. The API will return a maximum of 100 results per page. To retrieve additional results, you can use the `page` and `per_page` query parameters.  The `page` parameter is used to specify the page number. The first page is `1`. The `per_page` parameter is used to specify the number of results per page. The maximum number of results differs by resource type.  ## Sorting  Where offered, the API allows you to sort results by a specific field. To sort results use the `sort_by` query parameter with the root level field name as the value. The `sort_direction` parameter is used to specify the sort direction, either either `asc` (ascending) or `desc` (descending).  ## Filtering  Filtering is used to limit the results returned in a single request. The API supports filtering by certain fields in the response. To filter results, you can use the field as a query parameter.  For example, to filter the IP list to only return public IPv4 addresses, you can filter by the `type` field, as in the following request:  ```sh curl -H 'X-Auth-Token: my_authentication_token' \\   https://api.equinix.com/metal/v1/projects/id/ips?type=public_ipv4 ```  Only IP addresses with the `type` field set to `public_ipv4` will be returned.  ## Searching  Searching is used to find matching resources using multiple field comparissons. The API supports searching in resources that define this behavior. Currently the search parameter is only available on devices, ssh_keys, api_keys and memberships endpoints.  To search resources you can use the `search` query parameter.  ## Include and Exclude  For resources that contain references to other resources, sucha as a Device that refers to the Project it resides in, the Equinix Metal API will returns `href` values (API links) to the associated resource.  ```json {   ...   \"project\": {     \"href\": \"/metal/v1/projects/f3f131c8-f302-49ef-8c44-9405022dc6dd\"   } } ```  If you're going need the project details, you can avoid a second API request.  Specify the contained `href` resources and collections that you'd like to have included in the response using the `include` query parameter.  For example:  ```sh curl -H 'X-Auth-Token: my_authentication_token' \\   https://api.equinix.com/metal/v1/user?include=projects ```  The `include` parameter is generally accepted in `GET`, `POST`, `PUT`, and `PATCH` requests where `href` resources are presented.  To have multiple resources include, use a comma-separated list (e.g. `?include=emails,projects,memberships`).  ```sh curl -H 'X-Auth-Token: my_authentication_token' \\   https://api.equinix.com/metal/v1/user?include=emails,projects,memberships ```  You may also include nested associations up to three levels deep using dot notation (`?include=memberships.projects`):  ```sh curl -H 'X-Auth-Token: my_authentication_token' \\   https://api.equinix.com/metal/v1/user?include=memberships.projects ```  To exclude resources, and optimize response delivery, use the `exclude` query parameter. The `exclude` parameter is generally accepted in `GET`, `POST`, `PUT`, and `PATCH` requests for fields with nested object responses. When excluded, these fields will be replaced with an object that contains only an `href` field.

API version: 1.0.0
Contact: support@equinixmetal.com
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package metalv1

import (
	"encoding/json"
)

// checks if the InterconnectionMetroListMetrosInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &InterconnectionMetroListMetrosInner{}

// InterconnectionMetroListMetrosInner struct for InterconnectionMetroListMetrosInner
type InterconnectionMetroListMetrosInner struct {
	Code    *string `json:"code,omitempty"`
	Country *string `json:"country,omitempty"`
	Id      *string `json:"id,omitempty"`
	Name    *string `json:"name,omitempty"`
	// A list of providers and their equivalent regions available for connecting to the provider network.
	Providers            []InterconnectionMetroListMetrosInnerAllOfProvidersInner `json:"providers,omitempty"`
	AdditionalProperties map[string]interface{}
}

type _InterconnectionMetroListMetrosInner InterconnectionMetroListMetrosInner

// NewInterconnectionMetroListMetrosInner instantiates a new InterconnectionMetroListMetrosInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewInterconnectionMetroListMetrosInner() *InterconnectionMetroListMetrosInner {
	this := InterconnectionMetroListMetrosInner{}
	return &this
}

// NewInterconnectionMetroListMetrosInnerWithDefaults instantiates a new InterconnectionMetroListMetrosInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewInterconnectionMetroListMetrosInnerWithDefaults() *InterconnectionMetroListMetrosInner {
	this := InterconnectionMetroListMetrosInner{}
	return &this
}

// GetCode returns the Code field value if set, zero value otherwise.
func (o *InterconnectionMetroListMetrosInner) GetCode() string {
	if o == nil || IsNil(o.Code) {
		var ret string
		return ret
	}
	return *o.Code
}

// GetCodeOk returns a tuple with the Code field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InterconnectionMetroListMetrosInner) GetCodeOk() (*string, bool) {
	if o == nil || IsNil(o.Code) {
		return nil, false
	}
	return o.Code, true
}

// HasCode returns a boolean if a field has been set.
func (o *InterconnectionMetroListMetrosInner) HasCode() bool {
	if o != nil && !IsNil(o.Code) {
		return true
	}

	return false
}

// SetCode gets a reference to the given string and assigns it to the Code field.
func (o *InterconnectionMetroListMetrosInner) SetCode(v string) {
	o.Code = &v
}

// GetCountry returns the Country field value if set, zero value otherwise.
func (o *InterconnectionMetroListMetrosInner) GetCountry() string {
	if o == nil || IsNil(o.Country) {
		var ret string
		return ret
	}
	return *o.Country
}

// GetCountryOk returns a tuple with the Country field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InterconnectionMetroListMetrosInner) GetCountryOk() (*string, bool) {
	if o == nil || IsNil(o.Country) {
		return nil, false
	}
	return o.Country, true
}

// HasCountry returns a boolean if a field has been set.
func (o *InterconnectionMetroListMetrosInner) HasCountry() bool {
	if o != nil && !IsNil(o.Country) {
		return true
	}

	return false
}

// SetCountry gets a reference to the given string and assigns it to the Country field.
func (o *InterconnectionMetroListMetrosInner) SetCountry(v string) {
	o.Country = &v
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *InterconnectionMetroListMetrosInner) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InterconnectionMetroListMetrosInner) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *InterconnectionMetroListMetrosInner) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *InterconnectionMetroListMetrosInner) SetId(v string) {
	o.Id = &v
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *InterconnectionMetroListMetrosInner) GetName() string {
	if o == nil || IsNil(o.Name) {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InterconnectionMetroListMetrosInner) GetNameOk() (*string, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *InterconnectionMetroListMetrosInner) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *InterconnectionMetroListMetrosInner) SetName(v string) {
	o.Name = &v
}

// GetProviders returns the Providers field value if set, zero value otherwise.
func (o *InterconnectionMetroListMetrosInner) GetProviders() []InterconnectionMetroListMetrosInnerAllOfProvidersInner {
	if o == nil || IsNil(o.Providers) {
		var ret []InterconnectionMetroListMetrosInnerAllOfProvidersInner
		return ret
	}
	return o.Providers
}

// GetProvidersOk returns a tuple with the Providers field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InterconnectionMetroListMetrosInner) GetProvidersOk() ([]InterconnectionMetroListMetrosInnerAllOfProvidersInner, bool) {
	if o == nil || IsNil(o.Providers) {
		return nil, false
	}
	return o.Providers, true
}

// HasProviders returns a boolean if a field has been set.
func (o *InterconnectionMetroListMetrosInner) HasProviders() bool {
	if o != nil && !IsNil(o.Providers) {
		return true
	}

	return false
}

// SetProviders gets a reference to the given []InterconnectionMetroListMetrosInnerAllOfProvidersInner and assigns it to the Providers field.
func (o *InterconnectionMetroListMetrosInner) SetProviders(v []InterconnectionMetroListMetrosInnerAllOfProvidersInner) {
	o.Providers = v
}

func (o InterconnectionMetroListMetrosInner) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o InterconnectionMetroListMetrosInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Code) {
		toSerialize["code"] = o.Code
	}
	if !IsNil(o.Country) {
		toSerialize["country"] = o.Country
	}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	if !IsNil(o.Providers) {
		toSerialize["providers"] = o.Providers
	}

	for key, value := range o.AdditionalProperties {
		toSerialize[key] = value
	}

	return toSerialize, nil
}

func (o *InterconnectionMetroListMetrosInner) UnmarshalJSON(data []byte) (err error) {
	varInterconnectionMetroListMetrosInner := _InterconnectionMetroListMetrosInner{}

	err = json.Unmarshal(data, &varInterconnectionMetroListMetrosInner)

	if err != nil {
		return err
	}

	*o = InterconnectionMetroListMetrosInner(varInterconnectionMetroListMetrosInner)

	additionalProperties := make(map[string]interface{})

	if err = json.Unmarshal(data, &additionalProperties); err == nil {
		delete(additionalProperties, "code")
		delete(additionalProperties, "country")
		delete(additionalProperties, "id")
		delete(additionalProperties, "name")
		delete(additionalProperties, "providers")
		o.AdditionalProperties = additionalProperties
	}

	return err
}

type NullableInterconnectionMetroListMetrosInner struct {
	value *InterconnectionMetroListMetrosInner
	isSet bool
}

func (v NullableInterconnectionMetroListMetrosInner) Get() *InterconnectionMetroListMetrosInner {
	return v.value
}

func (v *NullableInterconnectionMetroListMetrosInner) Set(val *InterconnectionMetroListMetrosInner) {
	v.value = val
	v.isSet = true
}

func (v NullableInterconnectionMetroListMetrosInner) IsSet() bool {
	return v.isSet
}

func (v *NullableInterconnectionMetroListMetrosInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableInterconnectionMetroListMetrosInner(val *InterconnectionMetroListMetrosInner) *NullableInterconnectionMetroListMetrosInner {
	return &NullableInterconnectionMetroListMetrosInner{value: val, isSet: true}
}

func (v NullableInterconnectionMetroListMetrosInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableInterconnectionMetroListMetrosInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
